diff -ruN ../nakedmudv3.7/src/scripts/pychar.c src/scripts/pychar.c
--- ../nakedmudv3.7/src/scripts/pychar.c	2008-12-06 00:20:20.000000000 -0500
+++ src/scripts/pychar.c	2009-03-02 01:00:40.000000000 -0500
@@ -23,6 +23,7 @@
 #include "../socket.h"
 #include "../prototype.h"
 #include "../save.h"
+#include "../inform.h"
 
 #include "pyplugs.h"
 #include "scripts.h"
@@ -182,8 +183,7 @@
   else if(charGetRoom(ch) != NULL)
     return Py_BuildValue("O", roomGetPyFormBorrowed(charGetRoom(ch)));
   else {
-    Py_INCREF(Py_None);
-    return Py_BuildValue("O", Py_None);
+    return Py_BuildValue("");
   }
 }
 
@@ -194,8 +194,7 @@
   else if(charGetLastRoom(ch) != NULL)
     return Py_BuildValue("O", roomGetPyFormBorrowed(charGetLastRoom(ch)));
   else {
-    Py_INCREF(Py_None);
-    return Py_BuildValue("O", Py_None);
+    return Py_BuildValue("");
   }
 }
 
@@ -234,7 +233,7 @@
   if(ch == NULL) 
     return NULL;
   else if(charGetFurniture(ch) == NULL)
-    return Py_BuildValue("O", Py_None);
+    return Py_BuildValue("");
   else 
     return Py_BuildValue("O", objGetPyFormBorrowed(charGetFurniture(ch)));
 }
@@ -243,6 +242,29 @@
   return Py_BuildValue("i", self->uid);
 }
 
+PyObject *PyChar_gethidden(PyObject *self, void *closure) {
+  CHAR_DATA *ch = PyChar_AsChar(self);
+  if(ch != NULL)  return Py_BuildValue("i", charGetHidden(ch));
+  else            return NULL;  
+}
+
+PyObject *PyChar_getweight(PyObject *self, void *closure) {
+  CHAR_DATA *ch = PyChar_AsChar(self);
+  if(ch != NULL)  return Py_BuildValue("d", charGetWeight(ch));
+  else            return NULL;  
+}
+
+PyObject *PyChar_getbirth(PyObject *self, void *closure) {
+  CHAR_DATA *ch = PyChar_AsChar(self);
+  if(ch != NULL)  return Py_BuildValue("i", charGetBirth(ch));
+  else            return NULL;
+}
+
+PyObject *PyChar_getage(PyObject *self, void *closure) {
+  CHAR_DATA *ch = PyChar_AsChar(self);
+  if(ch != NULL)  return Py_BuildValue("d", difftime(current_time, charGetBirth(ch)));
+  else            return NULL;  
+}
 
 PyObject *PyChar_getprototypes(PyChar *self, void *closure) {
   CHAR_DATA *ch = PyChar_AsChar((PyObject *)self);
@@ -288,6 +310,7 @@
   } deleteListIterator(eq_i);
   PyObject *retval = Py_BuildValue("O", list);
   Py_DECREF(list);
+  deleteList(equipped);
   return retval;
 }
 
@@ -323,7 +346,7 @@
   else {
     SOCKET_DATA *sock = charGetSocket(ch);
     if(sock == NULL)
-      return Py_BuildValue("O", Py_None);
+      return Py_BuildValue("");
     return Py_BuildValue("O", socketGetPyFormBorrowed(sock));
   }
 }
@@ -430,6 +453,42 @@
   return 0;
 }
 
+int PyChar_sethidden(PyObject *self, PyObject *value, void *closure) {
+  CHAR_DATA *ch = NULL;
+  PYCHAR_CHECK_CHAR_EXISTS(PyChar_AsUid(self), ch);
+
+  if(value == NULL || value == Py_None)
+    charSetHidden(ch, 0);
+  else if(PyInt_Check(value))
+    charSetHidden(ch, PyInt_AsLong(value));
+  else {
+    PyErr_Format(PyExc_TypeError,
+		"Tried to change char %d's spot difficulty to an invalid type.",
+		 charGetUID(ch));
+    return -1;
+  }
+
+  return 0;
+}
+
+int PyChar_setweight(PyObject *self, PyObject *value, void *closure) {
+  CHAR_DATA *ch = NULL;
+  PYCHAR_CHECK_CHAR_EXISTS(PyChar_AsUid(self), ch);
+
+  if(value == NULL || value == Py_None)
+    charSetWeight(ch, 0.0);
+  else if(PyFloat_Check(value))
+    charSetWeight(ch, PyFloat_AsDouble(value));
+  else {
+    PyErr_Format(PyExc_TypeError,
+		"Tried to change char %d's weight to an invalid type.",
+		 charGetUID(ch));
+    return -1;
+  }
+
+  return 0;
+}
+
 int PyChar_setlookbuf(PyChar *self, PyObject *value, void *closure) {
   if (value == NULL) {
     PyErr_Format(PyExc_TypeError, "Cannot delete character's look buffer");
@@ -553,9 +612,8 @@
 
   int sex = sexGetNum(PyString_AsString(value));
   if(sex == SEX_NONE) {
-    char buf[SMALL_BUFFER];
-    sprintf(buf, "%s is an invalid sex type", PyString_AsString(value));
-    PyErr_Format(PyExc_TypeError, buf);
+    PyErr_Format(PyExc_TypeError, "%s is an invalid sex type",
+		 PyString_AsString(value));
     return -1;
   }
 
@@ -579,9 +637,8 @@
 
   int pos = posGetNum(PyString_AsString(value));
   if(pos == POS_NONE) {
-    char buf[SMALL_BUFFER];
-    sprintf(buf, "%s is an invalid position type", PyString_AsString(value));
-    PyErr_Format(PyExc_TypeError, buf);
+    PyErr_Format(PyExc_TypeError, "%s is an invalid position type", 
+		 PyString_AsString(value));
     return -1;
   }
 
@@ -600,6 +657,9 @@
     return -1;
   }
 
+  CHAR_DATA *ch;
+  PYCHAR_CHECK_CHAR_EXISTS(self->uid, ch);
+
   ROOM_DATA *room = NULL;
 
   if(PyRoom_Check(value))
@@ -607,7 +667,7 @@
   else if(PyString_Check(value))
     room = worldGetRoom(gameworld, 
 			get_fullkey_relative(PyString_AsString(value),
-					     get_script_locale()));
+					     get_smart_locale(ch)));
   else {
     PyErr_Format(PyExc_TypeError, 
 		 "Character's room must be a string value or a "
@@ -621,8 +681,6 @@
     return -1;
   }
 
-  CHAR_DATA *ch;
-  PYCHAR_CHECK_CHAR_EXISTS(self->uid, ch);
   // only move if we're not already here
   if(charGetRoom(ch) != room) {
     char_to_room(ch, room);
@@ -758,7 +816,6 @@
   }
 }
 
-
 //
 // returns whether or not the character can see something
 PyObject *PyChar_cansee(PyChar *self, PyObject *arg) {
@@ -804,6 +861,50 @@
   }
 }
 
+//
+// returns whether or not the character can see something
+PyObject *PyChar_see_as(PyChar *self, PyObject *arg) {
+  PyObject *py_tgt = NULL;
+
+  if(!PyArg_ParseTuple(arg, "O", &py_tgt)) {
+    PyErr_Format(PyExc_TypeError, "Must supply obj or mob for see_as");
+    return NULL;
+  }
+
+  CHAR_DATA *ch = PyChar_AsChar((PyObject *)self);  
+  if(ch == NULL) {
+    PyErr_Format(PyExc_TypeError, "Nonexistent character, %d, tried see_as",
+		 self->uid);
+    return NULL;
+  }
+  else {
+    OBJ_DATA    *obj = NULL;
+    CHAR_DATA  *pers = NULL;
+    EXIT_DATA  *exit = NULL;
+
+    if(PyChar_Check(py_tgt))
+      pers = PyChar_AsChar(py_tgt);
+    else if(PyObj_Check(py_tgt))
+      obj  = PyObj_AsObj(py_tgt);
+    else if(PyExit_Check(py_tgt))
+      exit = PyExit_AsExit(py_tgt);
+    else {
+      PyErr_Format(PyExc_TypeError, "Must supply obj, mob, or exit to see_as");
+      return NULL;
+    }
+
+    if(obj != NULL)
+      return Py_BuildValue("s", see_obj_as(ch, obj));
+    else if(pers != NULL)
+      return Py_BuildValue("s", see_char_as(ch, pers));
+    else if(exit != NULL)
+      return Py_BuildValue("s", see_exit_as(ch, exit));
+    else {
+      PyErr_Format(PyExc_StandardError, "Target of cansee did not exist!");
+      return NULL;
+    }
+  }
+}
 
 //
 // Returns TRUE if the character has the given variable set
@@ -939,10 +1040,12 @@
 //
 // equips a character with an item
 PyObject *PyChar_equip(PyChar *self, PyObject *args) {  
-  OBJ_DATA  *obj = NULL;
-  CHAR_DATA  *ch = NULL;
-  PyObject *pobj = NULL;
-  char      *pos = NULL;
+  OBJ_DATA      *obj = NULL;
+  CHAR_DATA      *ch = NULL;
+  PyObject     *pobj = NULL;
+  char          *pos = NULL;
+  const char *needed = NULL;
+  bool        forced = FALSE;
 
   // incase the equip fails, keep item in the original place.. here's the vars
   CHAR_DATA *old_carrier = NULL;
@@ -951,7 +1054,7 @@
   ROOM_DATA    *old_room = NULL;
   OBJ_DATA     *old_cont = NULL;
 
-  if (!PyArg_ParseTuple(args, "O|z", &pobj, &pos)) {
+  if (!PyArg_ParseTuple(args, "O|zb", &pobj, &pos, &forced)) {
     PyErr_Format(PyExc_TypeError, 
 		 "Character equip must be supplied with an item to equip!");
     return NULL;
@@ -989,8 +1092,11 @@
     try_unequip(old_wearer, obj);
   }
 
+  if(objIsType(obj, "worn"))
+    needed = wornGetPositions(obj);
+
   // try equipping the object. If we fail, put it back wherever it came from
-  if(!objIsType(obj, "worn") || !try_equip(ch, obj, pos,wornGetPositions(obj))){
+  if((!forced && !objIsType(obj, "worn")) || !try_equip(ch,obj,pos,needed)) {
     if(old_room != NULL)
       obj_to_room(obj, old_room);
     else if(old_cont != NULL)
@@ -999,6 +1105,11 @@
       obj_to_char(obj, old_carrier);
     else if(old_wearer != NULL)
       try_equip(ch, obj, old_pos, NULL);
+    if(pos == NULL)
+      message(ch, NULL, obj, NULL, TRUE, TO_CHAR, "You are already equipped in all possible positions for $o.");
+    else
+      message(ch, NULL, obj, NULL, TRUE, TO_CHAR, "You could not equip $o there.");
+
     return Py_BuildValue("i", 0);
     //    PyErr_Format(PyExc_StandardError,
     //		 "Character is already equipped in all possible positions!");
@@ -1026,11 +1137,77 @@
   
   obj = bodyGetEquipment(charGetBody(ch), pos);
   if(obj == NULL)
-    return Py_BuildValue("O", Py_None);
+    return Py_BuildValue("");
   else
     return Py_BuildValue("O", objGetPyFormBorrowed(obj));
 }
 
+PyObject *PyChar_getslots(PyChar *self, PyObject *args) {  
+  CHAR_DATA   *ch = PyChar_AsChar((PyObject *)self);
+  PyObject *pyobj = NULL;
+  OBJ_DATA   *obj = NULL;
+  if(ch == NULL) {
+    PyErr_Format(PyExc_StandardError, "Nonexistant character");
+    return NULL;
+  }
+
+  if(!PyArg_ParseTuple(args, "O", &pyobj)) {
+    PyErr_Format(PyExc_TypeError, "An item must be supplied.");
+    return NULL;
+  }
+  if(!PyObj_Check(pyobj)) {
+    PyErr_Format(PyExc_TypeError, "Missing object argument type.");
+    return NULL;
+  }
+  obj = PyObj_AsObj(pyobj);
+  if(obj == NULL) {
+    PyErr_Format(PyExc_StandardError,
+		 "Tried locate positions of nonexistent object, %d.", PyObj_AsUid(pyobj));
+    return NULL;
+  }
+
+  // return the slots
+  return Py_BuildValue("s", bodyEquippedWhere(charGetBody(ch), obj));
+}
+
+PyObject *PyChar_getslottypes(PyChar *self, PyObject *args) {  
+  CHAR_DATA   *ch = PyChar_AsChar((PyObject *)self);
+  PyObject *pyobj = NULL;
+  OBJ_DATA   *obj = NULL;
+  if(ch == NULL) {
+    PyErr_Format(PyExc_StandardError, "Nonexistant character");
+    return NULL;
+  }
+
+  if(!PyArg_ParseTuple(args, "O", &pyobj)) {
+    PyErr_Format(PyExc_TypeError, "An item must be supplied.");
+    return NULL;
+  }
+  if(!PyObj_Check(pyobj)) {
+    PyErr_Format(PyExc_TypeError, "Missing object argument type.");
+    return NULL;
+  }
+  obj = PyObj_AsObj(pyobj);
+  if(obj == NULL) {
+    PyErr_Format(PyExc_StandardError,
+		 "Tried locate positions of nonexistent object, %d.", PyObj_AsUid(pyobj));
+    return NULL;
+  }
+
+  PyObject *ret = PyList_New(0);
+  LIST   *where = parse_keywords(bodyEquippedWhere(charGetBody(ch), obj));
+  if(where > 0) {
+    LIST_ITERATOR *where_i = newListIterator(where);
+    const char        *pos = NULL;
+    ITERATE_LIST(pos, where_i) {
+      PyObject *str = Py_BuildValue("s", bodyposGetName(bodyGetPart(charGetBody(ch), pos)));
+      PyList_Append(ret, str);
+      Py_DECREF(str);
+    } deleteListIterator(where_i);
+  }
+  deleteListWith(where, free);
+  return ret;
+}
 
 PyObject *PyChar_attach(PyChar *self, PyObject *args) {  
   char *key = NULL;
@@ -1171,7 +1348,7 @@
 
 //
 // check to see if a character currently has an action in progress
-PyObject *PyChar_is_acting(PyChar *self, PyObject *args) {  
+PyObject *PyChar_is_acting(PyChar *self, void *closure) {  
   // make sure we exist
   CHAR_DATA *ch = PyChar_AsChar((PyObject *)self);
 
@@ -1189,7 +1366,7 @@
 
 //
 // interrupt any actions the character is currently performing
-PyObject *PyChar_interrupt_action(PyChar *self, PyObject *args) {  
+PyObject *PyChar_interrupt_action(PyChar *self, void *closure) {
   // make sure we exist
   CHAR_DATA *ch = PyChar_AsChar((PyObject *)self);
 
@@ -1264,6 +1441,26 @@
   }
 }
 
+PyObject *PyChar_hasPreferences(PyChar *self, PyObject *args) {
+  char *prefs = NULL;
+
+  // make sure we're getting passed the right type of data
+  if (!PyArg_ParseTuple(args, "s", &prefs)) {
+    PyErr_Format(PyExc_TypeError, "hasPrefs only accepts strings.");
+    return NULL;
+  }
+
+  // pull out the object and check the type
+  CHAR_DATA *ch = PyChar_AsChar((PyObject *)self);
+  if(ch != NULL)
+    return Py_BuildValue("i", bitIsSet(charGetPrfs(ch), prefs));
+  else {
+    PyErr_Format(PyExc_StandardError, 
+		 "Tried to check prefs of nonexistent char, %d.", self->uid);
+    return NULL;
+  }
+}
+
 //
 // returns whether or not the character belongs to one of the specified groups
 PyObject *PyChar_is_in_groups(PyChar *self, PyObject *args) {  
@@ -1286,6 +1483,42 @@
   }
 }
 
+PyObject *PyChar_append_look(PyObject *self, PyObject *args) {
+  char *desc = NULL;
+
+  // make sure we're getting passed the right type of data
+  if (!PyArg_ParseTuple(args, "s", &desc)) {
+    PyErr_Format(PyExc_TypeError, "Only strings can be appended to the look buffer.");
+    return NULL;
+  }
+
+  // pull out the object and check the type
+  CHAR_DATA *ch = PyChar_AsChar(self);
+  if(ch == NULL) {
+    PyErr_Format(PyExc_StandardError, 
+		 "Tried to append description to look buffer of nonexistent character, %d.", PyChar_AsUid(self));
+    return NULL;
+  }
+  else {
+    bufferCat(charGetLookBuffer(ch), desc);
+    return Py_BuildValue("");
+  }
+}
+
+PyObject *PyChar_clear_look(PyObject *self, void *closure) {
+  // pull out the object and check the type
+  CHAR_DATA *ch = PyChar_AsChar(self);
+  if(ch == NULL) {
+    PyErr_Format(PyExc_StandardError, 
+		 "Tried to clear look buffer of nonexistent character, %d.", PyChar_AsUid(self));
+    return NULL;
+  }
+  else {
+    bufferClear(charGetLookBuffer(ch));
+    return Py_BuildValue("i", 1);
+  }
+}
+
 
 
 //*****************************************************************************
@@ -1547,9 +1780,23 @@
   ITERATE_LIST(ch, ch_i)
     PyList_Append(list, charGetPyFormBorrowed(ch));
   deleteListIterator(ch_i);
-  PyObject *retval = Py_BuildValue("O", list);
-  Py_DECREF(list);
-  return retval;
+  return list;
+}
+
+PyObject *PyChar_is_abstract(PyObject *self, PyObject *args) {
+  char     *mob_key = NULL;
+  if (!PyArg_ParseTuple(args, "s", &mob_key)) {
+    PyErr_Format(PyExc_TypeError, 
+		 "is_abstract failed - it needs a mob key/locale.");
+    return NULL;
+  }
+
+  PROTO_DATA *proto = worldGetType(gameworld, "mproto", 
+				   get_fullkey_relative(mob_key, 
+							get_script_locale()));
+  if(proto == NULL || protoIsAbstract(proto))
+    return Py_BuildValue("i", 1);
+  return Py_BuildValue("i", 0);
 }
 
 PyMethodDef char_module_methods[] = {
@@ -1563,6 +1810,8 @@
   { "find_char_key", PyChar_find_char_key, METH_VARARGS,
     "finds a character (or group of chars) by their prototype. Finding by "
     "keywords is done with generic_find()" },
+  { "is_abstract",   PyChar_is_abstract, METH_VARARGS,
+    "Returns whether a mob with the specified prototype is abstract." },
   {NULL, NULL, 0, NULL}  /* Sentinel */
 };
 
@@ -1669,6 +1918,14 @@
 		      "Returns the character's socket if it exists.");
   PyChar_addGetSetter("sock",   PyChar_getsocket, NULL,
 		      "Returns the character's socket if it exists.");
+  PyChar_addGetSetter("hidden", PyChar_gethidden, PyChar_sethidden,
+		      "integer value representing how hidden the char is.");
+  PyChar_addGetSetter("weight", PyChar_getweight, PyChar_setweight,
+		      "double value representing how heavy we are.");
+  PyChar_addGetSetter("age", PyChar_getage, NULL,
+		      "how old, in seconds, are we");
+  PyChar_addGetSetter("birth", PyChar_getbirth, NULL,
+		      "when were we created");
 
   // add in all of our methods for the Char class
   PyChar_addMethod("attach", PyChar_attach, METH_VARARGS,
@@ -1698,26 +1955,40 @@
 		   "from whatever it is currently in/on.");
   PyChar_addMethod("get_equip", PyChar_getequip, METH_VARARGS,
 		   "Returns the person's equipment in the specified slot.");
+  PyChar_addMethod("get_slots", PyChar_getslots, METH_VARARGS,
+		   "Returns the slots occupied by the piece of equipment.");
+  PyChar_addMethod("get_slot_types", PyChar_getslottypes, METH_VARARGS,
+		   "Returns the slot types occupied by the equipment.");
   PyChar_addMethod("get_bodypct", PyChar_getbodypct, METH_VARARGS,
 		   "Returns the percent mass of the character's body taken up "
 		   "by the specified parts.");
-  PyChar_addMethod("isActing", PyChar_is_acting, METH_VARARGS,
+  PyChar_addMethod("isActing", PyChar_is_acting, METH_NOARGS,
 		   "Returns True if the character is currently taking an "
 		   "action, and False otherwise.");
   PyChar_addMethod("startAction", PyChar_start_action, METH_VARARGS,
 		   "Begins the character starting a new action");
-  PyChar_addMethod("interrupt", PyChar_interrupt_action, METH_VARARGS,
+  PyChar_addMethod("interrupt", PyChar_interrupt_action, METH_NOARGS,
 		   "Interrupts the character's current action.");
   PyChar_addMethod("getAuxiliary", PyChar_get_auxiliary, METH_VARARGS,
 		   "get's the specified piece of aux data from the char");
+  PyChar_addMethod("aux", PyChar_get_auxiliary, METH_VARARGS,
+		   "get's the specified piece of aux data from the char");
   PyChar_addMethod("cansee", PyChar_cansee, METH_VARARGS,
 		   "returns whether or not a char can see an obj or mob.");
+  PyChar_addMethod("see_as", PyChar_see_as, METH_VARARGS,
+		   "returns what the character sees the thing as.");
   PyChar_addMethod("page", PyChar_page, METH_VARARGS,
 		   "page a bunch of text to the character.");
   PyChar_addMethod("isinstance", PyChar_isinstance, METH_VARARGS,
 		   "returns whether or not the char inherits from the proto");
   PyChar_addMethod("isInGroup", PyChar_is_in_groups, METH_VARARGS,
 		   "returns whether or not the character belongs to one of the groups");
+  PyChar_addMethod("hasPrefs", PyChar_hasPreferences, METH_VARARGS,
+		   "Return if the character has the specified preference.");
+  PyChar_addMethod("append_look", PyChar_append_look, METH_VARARGS,
+		   "Append text to the character's look buffer.");
+  PyChar_addMethod("clear_look",  PyChar_clear_look, METH_VARARGS,
+		   "Clear the character's look buffer.");
 
   // add in all the getsetters and methods
   makePyType(&PyChar_Type, pychar_getsetters, pychar_methods);
diff -ruN ../nakedmudv3.7/src/scripts/pyevent.c src/scripts/pyevent.c
--- ../nakedmudv3.7/src/scripts/pyevent.c	2008-05-31 00:17:59.000000000 -0400
+++ src/scripts/pyevent.c	2009-03-02 01:00:40.000000000 -0500
@@ -18,6 +18,7 @@
 #include "pychar.h"
 #include "pyroom.h"
 #include "pyobj.h"
+#include "pyplugs.h"
 
 
 
@@ -42,10 +43,12 @@
       PyOwner = Py_None;
 
     PyObject *ret = PyObject_CallFunction(efunc, "OOs", PyOwner, edata, arg);
+    if(ret == NULL)
+      log_pyerr("Error finishing Python event");
     Py_XDECREF(ret);
   }
 
-  // decrease the reference on our function and data
+  // decrease the reference on our function and data, as well as our owner
   Py_XDECREF(tuple);
 }
 
@@ -70,8 +73,8 @@
 
   // try to parse all of our values
   if(!PyArg_ParseTuple(args, "OdO|Os", &PyOwner, &delay, &efunc, &edata, &arg)){
-    PyErr_Format(PyExc_TypeError, 
-		 "Invalid arguments provided to event handler");
+    //PyErr_Format(PyExc_TypeError, 
+    //"Invalid arguments provided to event handler");
     return NULL;
   }
 
@@ -84,7 +87,7 @@
 
   // figure out what type of data our owner is
   if(PyOwner == Py_None) {
-    owner = Py_None;
+    owner = NULL;
     sprintf(otype, "none");
   }
   else if(PyChar_Check(PyOwner)) {
@@ -107,7 +110,7 @@
   }
 
   // make sure the owner exists
-  if(owner == NULL) {
+  if(PyOwner != Py_None && owner == NULL) {
     PyErr_Format(PyExc_StandardError, "Owner supplied does not exist in game");
     return NULL;
   }
diff -ruN ../nakedmudv3.7/src/scripts/pyexit.c src/scripts/pyexit.c
--- ../nakedmudv3.7/src/scripts/pyexit.c	2008-05-31 00:17:59.000000000 -0400
+++ src/scripts/pyexit.c	2009-03-02 01:00:40.000000000 -0500
@@ -13,6 +13,7 @@
 #include "../room.h"
 #include "../exit.h"
 #include "../world.h"
+#include "../hooks.h"
 
 #include "scripts.h"
 #include "pyroom.h"
@@ -103,10 +104,17 @@
 PyObject *PyExit_getdest(PyObject *self, void *closure) {
   EXIT_DATA *ex = PyExit_AsExit((PyObject *)self);
   if(ex == NULL) return NULL;
-  else {
-    ROOM_DATA *dest = worldGetRoom(gameworld, exitGetTo(ex));
-    return Py_BuildValue("O", (dest ? roomGetPyFormBorrowed(dest) : Py_None));
-  }
+  ROOM_DATA *dest = worldGetRoom(gameworld, exitGetToFull(ex));
+  if(dest == NULL)
+    return Py_BuildValue("");
+  return Py_BuildValue("O", roomGetPyFormBorrowed(dest));
+}
+
+PyObject *PyExit_getdestproto(PyObject *self, void *closure) {
+  EXIT_DATA *ex = PyExit_AsExit((PyObject *)self);
+  if(ex == NULL) 
+    return NULL;
+  return Py_BuildValue("s", exitGetToFull(ex));
 }
 
 PyObject *PyExit_getspotdiff(PyObject *self, void *closure) {
@@ -464,6 +472,25 @@
   return Py_BuildValue("i", 1);
 }
 
+PyObject *PyExit_filldoor(PyExit *self, void *closure) {
+  EXIT_DATA *ex = PyExit_AsExit((PyObject *)self);
+  if(ex == NULL) {
+    PyErr_Format(PyExc_StandardError, "Tried to edit nonexistant exit, %d.",
+		 self->uid);
+    return NULL;
+  }
+
+  exitSetClosable(ex, FALSE);
+  exitSetClosed(ex, FALSE);
+  exitSetLocked(ex, FALSE);
+  exitSetKeywords(ex, "");
+  exitSetName(ex, "");
+  exitSetKey(ex, "");
+
+  // success!
+  return Py_BuildValue("i", 1);
+}
+
 
 PyObject *PyExit_open(PyExit *self, PyObject *value) {
   EXIT_DATA *ex = PyExit_AsExit((PyObject *)self);
@@ -473,8 +500,14 @@
     return NULL;
   }
 
+  bool was_closed = exitIsClosed(ex);
+
   exitSetClosed(ex, FALSE);
   exitSetLocked(ex, FALSE);
+
+  if(was_closed && exitGetRoom(ex))
+    hookRun("room_change", hookBuildInfo("rm", exitGetRoom(ex)));
+
   return Py_BuildValue("i", 1);
 }
 
@@ -487,7 +520,13 @@
     return NULL;
   }
 
+  bool was_open = !exitIsClosed(ex);
+
   exitSetClosed(ex, TRUE);
+
+  if(was_open && exitGetRoom(ex))
+    hookRun("room_change", hookBuildInfo("rm", exitGetRoom(ex)));
+
   return Py_BuildValue("i", 1);
 }
 
@@ -499,8 +538,15 @@
     return NULL;
   }
 
+  bool was_open     = !exitIsClosed(ex);
+  bool was_unlocked = !exitIsLocked(ex);
+
   exitSetClosed(ex, TRUE);
   exitSetLocked(ex, TRUE);
+
+  if((was_open || was_unlocked) && exitGetRoom(ex))
+    hookRun("room_change", hookBuildInfo("rm", exitGetRoom(ex)));
+
   return Py_BuildValue("i", 1);
 }
 
@@ -512,7 +558,13 @@
     return NULL;
   }
 
+  bool was_locked = exitIsLocked(ex);
+
   exitSetLocked(ex, FALSE);
+
+  if(was_locked && exitGetRoom(ex))
+    hookRun("room_change", hookBuildInfo("rm", exitGetRoom(ex)));
+
   return Py_BuildValue("i", 1);
 }
 
@@ -609,12 +661,16 @@
 			"returns the exit's universal ID nubmer");
     PyExit_addGetSetter("spot_diff", PyExit_getspotdiff, PyExit_setspotdiff,
 			"integer value representing how hidden the exit is.");
+    PyExit_addGetSetter("hidden", PyExit_getspotdiff, PyExit_setspotdiff,
+			"integer value representing how hidden the exit is.");
     PyExit_addGetSetter("pick_diff", PyExit_getpickdiff, PyExit_setpickdiff,
 			"integer value representing how hard lock is to pick.");
     PyExit_addGetSetter("key", PyExit_getkey, PyExit_setkey,
 			"String or Obj value for obj class that unlocks exit.");
     PyExit_addGetSetter("dest", PyExit_getdest, PyExit_setdest,
 			"String or Room value for room this exit leads to.");
+    PyExit_addGetSetter("destproto", PyExit_getdestproto, NULL,
+			"return the class name of our our destiantion.");
     PyExit_addGetSetter("name", PyExit_getname, PyExit_setname,
 			"The name of the door on the exit.");
     PyExit_addGetSetter("keywords", PyExit_getkeywords, PyExit_setkeywords,
@@ -641,6 +697,8 @@
     PyExit_addMethod("makedoor", PyExit_makedoor, METH_VARARGS,
 		     "Make a door on the exit. Takes name, keywords, and "
 		     "optionally opposite, closed, locked, and key.");
+    PyExit_addMethod("filldoor", PyExit_filldoor, METH_NOARGS,
+		     "remove a door that was made on the exit.");
     PyExit_addMethod("open", PyExit_open, METH_VARARGS,
 		     "Opens the exit if there's a door. Also unlocks.");
     PyExit_addMethod("close", PyExit_close, METH_VARARGS,
diff -ruN ../nakedmudv3.7/src/scripts/pymud.c src/scripts/pymud.c
--- ../nakedmudv3.7/src/scripts/pymud.c	2008-12-06 00:20:20.000000000 -0500
+++ src/scripts/pymud.c	2009-03-02 01:00:40.000000000 -0500
@@ -41,9 +41,6 @@
 // a list of methods to add to the mud module
 LIST *pymud_methods = NULL;
 
-// a placeholder of the movement command, as set by one of our modules
-PyObject *py_cmd_move = NULL;
-
 
 
 //*****************************************************************************
@@ -109,9 +106,10 @@
 PyObject *mud_format_string(PyObject *self, PyObject *args) {
   char *string = NULL;
   bool indent  = TRUE;
+  int  width   = SCREEN_WIDTH;
 
   // parse all of the values
-  if (!PyArg_ParseTuple(args, "s|b", &string, &indent)) {
+  if (!PyArg_ParseTuple(args, "s|bi", &string, &indent, &width)) {
     PyErr_Format(PyExc_TypeError, 
 		 "Can not format non-string values.");
     return NULL;
@@ -120,7 +118,7 @@
   // dup the string so we can work with it and not intrude on the PyString data
   BUFFER *buf = newBuffer(MAX_BUFFER);
   bufferCat(buf, string);
-  bufferFormat(buf, SCREEN_WIDTH, (indent ? PARA_INDENT : 0));
+  bufferFormat(buf, width, (indent ? PARA_INDENT : 0));
   PyObject *ret = Py_BuildValue("s", bufferString(buf));
   deleteBuffer(buf);
   return ret;
@@ -382,6 +380,16 @@
       return NULL;
     }
   }
+  else if(PyRoom_Check(thing)) {
+    ROOM_DATA *room = PyRoom_AsRoom(thing);
+    if(room != NULL)
+      extract_room(room);
+    else {
+      PyErr_Format(PyExc_StandardError,
+		   "Tried to extract nonexistent room!");
+      return NULL;
+    }
+  }
   
   // success
   return Py_BuildValue("i", 1);
@@ -432,6 +440,12 @@
   return Py_BuildValue("s", bufferString(motd));
 }
 
+//
+// returns the mud's message of the day
+PyObject *mud_get_greeting(PyObject *self, PyObject *args) {
+  return Py_BuildValue("s", bufferString(greeting));
+}
+
 PyObject *mud_log_string(PyObject *self, PyObject *args) {
   char *mssg = NULL;
   if(!PyArg_ParseTuple(args, "s", &mssg)) {
@@ -448,24 +462,6 @@
   return Py_BuildValue("i", 1);
 }
 
-PyObject *mud_set_cmd_move(PyObject *self, PyObject *args) {
-  PyObject *cmd = NULL;
-  if(!PyArg_ParseTuple(args, "O", &cmd)) {
-    PyErr_Format(PyExc_TypeError, "a command must be suppled");
-    return NULL;
-  }
-
-  // make sure it's a function
-  if(!PyFunction_Check(cmd)) {
-    PyErr_Format(PyExc_TypeError, "a command must be suppled");
-    return NULL;
-  }
-
-  Py_XDECREF(py_cmd_move);
-  py_cmd_move = cmd;
-  return Py_BuildValue("i", 1);
-}
-
 PyObject *mud_is_race(PyObject *self, PyObject *args) {
   char       *race = NULL;
   bool player_only = FALSE;
@@ -536,10 +532,10 @@
 		  "equivalent to parse_args written in C");
   PyMud_addMethod("get_motd", mud_get_motd, METH_VARARGS,
 		  "returns the mud's message of the day");
+  PyMud_addMethod("get_greeting", mud_get_greeting, METH_VARARGS,
+		  "returns the mud's login greeting");
   PyMud_addMethod("log_string", mud_log_string, METH_VARARGS,
 		  "adds a string to the mudlog");
-  PyMud_addMethod("set_cmd_move", mud_set_cmd_move, METH_VARARGS,
-		  "sets the movement command");
   PyMud_addMethod("is_race", mud_is_race, METH_VARARGS,
 		  "returns whether or not the string is a valid race.");
   PyMud_addMethod("list_races", mud_list_races, METH_VARARGS,
@@ -553,7 +549,3 @@
   globals = PyDict_New();
   Py_INCREF(globals);
 }
-
-void *get_cmd_move(void) {
-  return py_cmd_move;
-}
diff -ruN ../nakedmudv3.7/src/scripts/pymud.h src/scripts/pymud.h
--- ../nakedmudv3.7/src/scripts/pymud.h	2008-05-31 00:17:59.000000000 -0400
+++ src/scripts/pymud.h	2009-03-02 01:00:40.000000000 -0500
@@ -22,8 +22,4 @@
 // new methods, see pymud.c
 void PyMud_addMethod(const char *name, void *f, int flags, const char *doc);
 
-//
-// returns the current defined cmd_move
-void *get_cmd_move(void);
-
 #endif //__PYMUD_H
